clear all
close all

% Costruisco i lifting steps
LS_Haar = liftwave('haar');
[Hs_Haar, Gs_Haar, Ha_Haar, Ga_Haar] = wave2lp('haar');
% P_Haar si costruisce in questo modo (se non funziona i valori vanno inseriti a
% mano dando solo il comando even(Hs_Haar) e cosi via)
P_Haar = [even(Hs_Haar) even(Gs_Haar); odd(Hs_Haar) odd(Gs_Haar)];

LS_db4 = liftwave('db4');
[Hs_db4, Gs_db4, Ha_db4, Ga_db4] = wave2lp('db4');
P_db4 = [even(Hs_db4) even(Gs_db4) odd(Hs_db4) odd(Gs_db4)];

LS_cdf = liftwave('cdf3.1');
[Hs_cdf, Gs_cdf, Ha_cdf, Ga_cdf] = wave2lp('cdf3.1');
P_cdf = [even(Hs_cdf) even(Gs_cdf); odd(Hs_cdf) odd(Gs_cdf)];

[LoD, HiD, LoR, HiR] = ls2filt(LS_Haar);

J = 3;
cA{1} = imread('einstein.tif');
cA_ls{1} = cA{1};

%Analisi
for k=1:J
    
    [cA_ls{k+1}, cH_ls{k+1}, cV_ls{k+1}, cD_ls{k+1}] = dwt2(cA_ls{k}, LoD, HiD);
    [cA{k+1}, cH{k+1}, cV{k+1}, cD{k+1}] = dwt2(cA{k}, 'haar');
    
end

figure, imshow(cA_ls{J}, []);
figure, imshow(cA{J}, []);

im_p=cA{J+1};
im_p_ls = im_p;

%Sintesi (NB: potrebbe venire la dimensione della matrice ricostruita una
%riga e una colonna pi?? larga, perch?? nell'analisi si arrotonda la
%dimensione dell'immagine divisa per 2)
for k=J+1:-1:2
    
    im_p = idwt2(im_p, cH{k}, cV{k}, cD{k}, 'haar');
    im_p_ls = idwt2(im_p_ls, cH_ls{k}, cV_ls{k}, cD_ls{k}, LoR, HiR);
    
end

figure, imshow(im_p, []), title('Image perfectly reconstructed');
figure, imshow(im_p_ls, []), title('Image perfectly reconstructed (lifting scheme)');